'FFSubmenu=Tools
'FFName=Missing Image

'FFSkriptName=MissingImage.vbs
'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=1.00
'FFVersion=2.90.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html
'FFSkriptFiles=
'FFSkriptDirectory=

' ********************************************************************
' MissingImage.vbs (Skript fr FixFoto)
'
' Copyright Harald Maeckler, Dsseldorf 2011
'
'** Start Kurzbeschreibung *******************************************
'
' Missing Image / Version 1.00
' =======================
'
' Zweck des Skripts:
' Suche nach fehlenden, bearbeiteten Bildern in einem zweiten Ordner.
' 
' Voraussetzung:
' Die Bilder im zweiten Ordner mssen im Namen den Stammnamen der Bilder im aktuellen
' Ordner enthalten. Sie drfen aber beliebige Zustze enthalten.
'
' Beendet wird das Skript durch Anklicken von 'Abbruch' oder dem 'x' rechts oben im 
' roten Feld.
'
' Beschreibung
' --------------
' Mit 'Start' wird berprft, ob alle im Computerverzeichnis vorhandenen Bilder im
' definierten zweiten Ordern vorhanden sind.
'
' Wird ein nicht vorhandenes Bild gefunden, wird dieses angezeigt und nachgefragt, ob 
' es geladen werden soll, die Suche fortgesetzt werden soll oder das Skript bis zum
' Ende ohne weitere Zwischenmeldungen durchlaufen soll.
'
' Wird die Suche bis zum Ende durchgefhrt, wird in einer Schlussmeldung angezeigt, 
' wieviel Bilder nicht gefunden wurden.
'
' Anmerkung:
' Das Skript kann auch direkt ohne Anzeige der Bedienoberflche gestartet werden. Dazu
' muss man bei festgehaltener Shift-Taste das Skript mit der linken Maustaste doppelt 
' anklicken. Natrlich muss vorher der zweite Ordner definiert sein.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Dann 
' wird die Skriptdatei gelscht und abschlieend die FixFotoScript.ini bereinigt.
'
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'
'** Ende Kurzbeschreibung ********************************************
'
' Version 1.00 vom 03.11.2011	- Betaversion
' ********************************************************************

Option Explicit

const SkriptName = "MissingImage.vbs"
const RegSchluessel = "FF_MissingImage"

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch	'Kurzbeschreibung
const ForReading = 1, ForWriting = 2
Abbruch = false

Dim objFS,WshShell										'ObjektFile
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false	'Lschroutine

'bunte Button
const schrift = "Arial"		'Schrift
const sg = 14				'Schriftgre

const weiss 	= "255 255 255"
const schwarz 	= "000 000 000"
const dunkelgrau = "060 060 060"
const grau 		= "210 210 210"
const hellgrau 	= "240 240 240"
const rot 		= "255 000 000"
const hellrot 	= "255 070 070"
const gruen 	= "000 128 000"
const hellgruen = "000 160 000"
const dunkelgelb = "220 220 000"
const gelb		= "255 255 000"
const blau 		= "036 000 192"
const hellblau 	= "070 030 255"
const lila 		= "190 005 175"

Dim X,Y					'Buttonbreite und Hhe
Dim tb,th,RGB_Array		'Textbreite und Hhe, RGB-Array
Dim ImagePath
ImagePath = FF_GetScriptPath & "\MeckiScript\MissingImage\"
Dim img_Hinweis,img_Hilfe,img_Abbruch,img_Start
img_Hinweis	= ImagePath & "img_Hinweis.tif"
img_Hilfe	= ImagePath & "img_Hilfe.tif"
img_Abbruch	= ImagePath & "img_Abbruch.tif"
img_Start	= ImagePath & "img_Start.tif"

'Allgemein
Dim Ordner,xOrdner
Dim Direktaufruf : Direktaufruf = false

'------------------------------------------------------------------------
call Main
Set objFS = nothing
Set WshShell = nothing
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if not objFS.FileExists(FF_GetScriptPath & "\" & SkriptName) then	'Kontrolle ob Name unverndert ist
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'Registry auslesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel
Ordner =  FF_GetProfile (RegSchluessel,"Ordner")
if not objFS.FolderExists(Ordner) then Ordner = FF_GetImagePath

'Direktaufruf ?
if FF_CheckKey = 16 then	'Shift-Taste
	Direktaufruf = true
	
	if len(Ordner) = 0 then
		msgbox "Es muss zuerst der zweite Ordner gewhlt werden!",vbInformation,"Hinweis"
	elseif FF_GetImagePath = Ordner then
		msgbox "Der zweite Ordner" & vbNewLine & "darf nicht der aktuelle Ordner sein!",vbExclamation,"Abbruch"
	else
		call Bildschleife
	end if

	exit sub
end if

'** Start Dialog MissingImage **
FF_AddDialog "MissingImage",121,80
FF_AddControl "MissingImage","Zweiter Ordner","GROUP",8,28,107,25
FF_AddControl "MissingImage","Ordner","SLEDIT",13,37,84,10
FF_SetControlStyle "MissingImage","Ordner",2048
FF_AddControl "MissingImage","...","BUTTON",100,37,10,10
FF_AddControl "MissingImage","Fortschritt","PROGRESS",8,56,107,5
FF_AddControl "MissingImage","&delete","BUTTON",0,0,1,1
FF_AddControl "MissingImage","img_Hilfe","IMAGE",13,65,11,11
FF_AddControl "MissingImage","img_Abbruch","IMAGE",42,65,33,11
FF_AddControl "MissingImage","img_Start","IMAGE",77,65,33,11
FF_AddControl "MissingImage","img_Hinweis","IMAGE",4,4,113,19
'** End Dialog MissingImage **

FF_SetControl "MissingImage","Ordner",Ordner

if Version_OK("3.30.06") then
	FF_SetControlTooltip "MissingImage","Ordner",Ordner
end if

'Symbole laden
if not objFS.FolderExists(ImagePath) then
	objFS.CreateFolder(ImagePath)
end if
FF_OpenDialog "MissingImage"
call Design

FF_ActivateControl "MissingImage","&delete"

do
	Select Case FF_ShowDialog ("MissingImage")
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "..."
		FF_SetCurrentPath Ordner
		xOrdner = FF_EnterPath(false,"Wahl des zweiten Ordners")
		if len(xOrdner) > 2 then
			Ordner = xOrdner
			FF_SetControl "MissingImage","Ordner",Ordner
			if Version_OK("3.30.06") then
				FF_SetControlTooltip "MissingImage","Ordner",Ordner
			end if
		end if
	Case "img_Hilfe"
		'FF_SetControl "MissingImage","Fortschritt",65	'############## nur fr Screenshot
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "img_Start"
		if len(Ordner) = 0 then
			msgbox "Es muss zuerst der zweite Ordner gewhlt werden!",vbInformation,"Hinweis"
		elseif FF_GetImagePath = Ordner then
			msgbox "Der zweite Ordner" & vbNewLine & "darf nicht der aktuelle Ordner sein!",vbExclamation,"Abbruch"
		else
			call Bildschleife
			exit do
		end if
	Case "CANCEL","img_Abbruch"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("MissingImage")

if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim TBreite	: TBreite = LaengeMax * 2.6 + 10
const THoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",TBreite,THoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,TBreite,THoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",TBreite/2-15,THoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

on error resume next

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen
Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\MissingImage"
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub Bildschleife
Dim Bilder,Array,element,sBaseName,sExt,BildB
Dim Anz,n,M
Dim f,f1,fc,Liste
Dim Durchlauf : Durchlauf = false

if not objFS.FolderExists(Ordner) then
	msgbox "Der Ordner" & vbNewLine & Ordner & vbNewline & "wurde nicht gefunden!",vbExclamation,"Abbruch"
	exit sub
end if

Bilder = FF_GetSelection(0)		'alle Bilder der Computeransicht
Array = split(Bilder,vbNewLine)
Anz = ubound(Array) + 1
n = 0 : m = 0

Set f = objFS.GetFolder(Ordner)
Set fc = f.Files
For Each f1 in fc
	Liste = Liste & f1.name		'alle Bilder des zweiten Ordners
Next

for each element in Array
	n = n + 1
	if not Direktaufruf then FF_SetControl "MissingImage","Fortschritt",(n+1)/Anz*100
	sBaseName = objFS.GetBaseName(element)

	if instr(Liste,sBaseName) = 0 then
		m = m +1
		if not Durchlauf then
			Antwort = 	msgbox("Es fehlt das Bild" & vbNewLine & objFS.GetFileName(element) & vbNewLine & vbNewLine & _
						"Soll es geladen werden?" & vbNewLine & vbNewLine & _
						"- bei <Nein> wird weiter nach fehlenden Bildern gesucht" & vbNewLine & _
						"- bei <Abbrechen> erfolgt der Durchlauf bis zum Ende" & vbNewLine & _
						"   ohne Zwischenmeldungen",vbYesNoCancel + vbInformation,"Zwischenmeldung")
			if Antwort = vbYes then
				FF_LoadImage element
				FF_ImportImage element
				'FF_Reload
				'FF_SetImageName elment
				exit sub
			elseif Antwort = vbCancel then
				Durchlauf = true
			end if
		end if
	end if
next

msgbox "Von " & n & " Bildern fehlte(n) " & m & " Bild(er)!",vbInformation,"Schlussmeldung"

End Sub
'---------------------------------------------------------------------
Function Version_OK(MinVersion)
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'---------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'Werte_Lesen
Ordner = FF_GetControl("MissingImage","Ordner")

'Werte schreiben
FF_WriteProfile RegSchluessel,"Ordner",Ordner

End Sub
'==================== bunte Button ============================
Sub Design

'img_Hinweis
if not objFS.FolderExists(img_Hinweis) then
	X = FF_GetControlWidth("MissingImage","img_Hinweis")
	Y = FF_GetControlHeight("MissingImage","img_Hinweis")
	call Symbolgenerator (hellgrau,hellgrau,"berprfung ob alle Bilder der Comp.-Ansicht",blau,400,2,1)
	call Symbolgenerator (grau,grau,"in einem zweiten Ordner vorhanden sind",blau,400,2,2)
	FF_SaveImage img_Hinweis,0
end if
FF_SetControl "MissingImage","img_Hinweis",img_Hinweis

'img_Hilfe
if not objFS.FolderExists(img_Hilfe) then
	X = FF_GetControlWidth("MissingImage","img_Hilfe")	-2	'-2 erzeugt schmalen Rand
	Y = FF_GetControlHeight("MissingImage","img_Hilfe")	-2
	call Symbolgenerator (dunkelgelb,gelb,"?",schwarz,600,1,1)
	FF_SaveImage img_Hilfe,0
end if
FF_SetControl "MissingImage","img_Hilfe",img_Hilfe

'img_Abbruch
if not objFS.FolderExists(img_Abbruch) then
	X = FF_GetControlWidth("MissingImage","img_Abbruch")	'-2
	Y = FF_GetControlHeight("MissingImage","img_Abbruch")	'-2
	call Symbolgenerator (rot,hellrot,"Abbruch",weiss,600,1,1)
	FF_SaveImage img_Abbruch,0
end if
FF_SetControl "MissingImage","img_Abbruch",img_Abbruch

'img_Start
if not objFS.FolderExists(img_Start) then
	X = FF_GetControlWidth("MissingImage","img_Start")	'-2
	Y = FF_GetControlHeight("MissingImage","img_Start")	'-2
	call Symbolgenerator (gruen,hellgruen,"Start",weiss,600,1,1)
	FF_SaveImage img_Start,0
end if
FF_SetControl "MissingImage","img_Start",img_Start

End Sub
'==============================================================
Sub Symbolgenerator (farbeU,farbeO,text,textfarbe,ss,zz,zn)
'Erzeugung des Symbols
' farbeU = Farbe der unteren Hlfte
' frabeO = Farbe der oberen Hlfte
' ss	 = Schriftstrke (1-1000; 400=normal)
' zz	 = Zeilenzahl
' zn	 = Zeilennummer

Dim kY 'Korrektur in der Y-Achse

if zn = 1 then
	FF_NewImage X,Y\2,Farbreferenz(farbeU)
	RGB_Array = split(farbeO)
	FF_ExtendCanvas 0,0,Y-Y\2,0,RGB_Array(0),RGB_Array(1),RGB_Array(2)
end if

th = FF_GetTextHeight(text,sg,ss,false,false,schrift)
tb = FF_GetTextWidth(text,sg,ss,false,false,schrift)

if zz = 1 then			'1 Zeile
	kY = 0
elseif zz = 2 then		'2 Zeilen
	if zn = 1 then
		kY = -th/2		' davon 1. Zeile
	elseif zn = 2 then
		kY = +th/2		' und 2. Zeile
	end if
end if
FF_DrawText text,(X-tb)\2,(Y-th)\2+kY,sg,0,ss,false,false,schrift,Farbreferenz(textfarbe)

End Sub
'==============================================================
Function Farbreferenz (RGB_Wert)
'Umwandlung RGB-Wert ("000 000 000" bis "255 255 255") zu Farbreferenz (0 - 16777215)

RGB_Array = split(RGB_Wert)
Farbreferenz = RGB_Array(0) + RGB_Array(1) * (2^8) + RGB_Array(2) * (2^16)

End Function
'======================== Ende ================================
